--
-- Tank content of a tractor is saved
--
-- @author  Stefan Geiger
-- @date  30/04/09
--
-- Copyright (C) GIANTS Software GmbH, Confidential, All Rights Reserved.

local origMotorizedGetSaveAttributesAndNodes = Motorized.getSaveAttributesAndNodes;
local origMotorizedLoadFromAttributesAndNodes = Motorized.loadFromAttributesAndNodes;

Motorized.getSaveAttributesAndNodes = function(self, nodeIdent)
    local attributes, nodes;
    if origMotorizedGetSaveAttributesAndNodes ~= nil then
        attributes, nodes = origMotorizedGetSaveAttributesAndNodes(self, nodeIdent);
    end;
    local modStr = 'fuelFillLevel="'..self.fuelFillLevel..'"';
    if attributes == nil then
        attributes = modStr;
    else
        attributes = attributes .. " "..modStr;
    end;
    return attributes, nodes;
end;

Motorized.loadFromAttributesAndNodes = function(self, xmlFile, key, resetVehicles)
    local attributes, nodes;
    if origMotorizedLoadFromAttributesAndNodes ~= nil then
        local r = origMotorizedLoadFromAttributesAndNodes(self, xmlFile, key, resetVehicles);
        if r ~= BaseMission.VEHICLE_LOAD_OK then
            return r;
        end;
    end;

    if not resetVehicles then
        local fuelFillLevel = getXMLFloat(xmlFile, key.."#fuelFillLevel");
        if fuelFillLevel ~= nil then
            self:setFuelFillLevel(fuelFillLevel);
        end;
    end;
    return BaseMission.VEHICLE_LOAD_OK;
end;
